#if ! defined Already_Included_Util
#define Already_Included_Util


#include <stdio.h>
#include <limits.h>
#if defined(sparc)
#    include <values.h>
#else
#    include <float.h>
#endif

#if !defined(MAXINT)
#    define MAXINT INT_MAX
#endif
#if !defined(MAXDOUBLE)
#    define MAXDOUBLE DBL_MAX
#endif

#include <basic/assert.h>

#ifdef __SUNPRO_CC
template<class T,class S> inline T max(T x, S y) {
	if (x >= y) return x; else return y;
	}
#else
template<class T> inline T max(T x, T y) {
	if (x >= y) return x; else return y;
	}
#endif

template<class T> inline T max(T x, T y, T z) {
	if (x >= y) return max(x,z); else return max(y,z);
	}

template<class T> inline T min(T x, T y) {
	if (x <= y) return x; else return y;
	}
template<class T> inline T min(T x, T y, T z) {
	if (x <= y) return min(x,z); else return min(y,z);
	}

template<class T> inline void set_max(T &m, T x) {
	if (m < x) m = x;
	}
template<class T> inline void set_min(T &m, T x) {
	if (m > x) m = x;
	}

template<class T> inline void swap(T &i, T &j) {
    T tmp;
    tmp = i;
    i = j;
    j = tmp;
}

template<class T> inline T copy(const T &t) { return t; }

inline int
check_pos_mul(int x, int y) {
#ifndef NDEBUG
    if (x != 0)
        assert(((MAXINT)/4) / x > y);
#endif
    return x * y;
}

inline int
check_mul(int x, int y) {
#ifdef NDEBUG
    return x*y;
#else
    if (x >= 0) {
        if (y >= 0)
            return check_pos_mul(x, y);
        else
            return -check_pos_mul(x, -y);
    } else if (y >= 0)
        return -check_pos_mul(-x, y);
    else
        return check_pos_mul(-x, -y);
#endif
}

inline int int_div(int a, int b) {
        int result;
	assert(b > 0);
	if (a>0) result = a/b;
	else     result = -((-a+b-1)/b);
	return result;
	}

inline int int_mod(int a, int b) {
	return a-b*int_div(a,b);
	};
inline int int_mod_hat(int a, int b) {
	int r;
	assert(b > 0);
	r = a-b*int_div(a,b);
	if (r > -(r-b)) r -= b;
	return r;
	};

inline
int gcd(int b, int a) /* First argument is non-negative */
    {
    assert(a >= 0);
    assert(b >= 0);
    if (b == 1)
	return (1);
    while (b != 0) 
	{
	int t = b;
	b = a % b;
	a = t;
	};
    return (a);
    }

inline
int lcm(int b, int a) /* First argument is non-negative */
    {
    assert(a >= 0);
    assert(b >= 0);
    return a*b/gcd(a,b);
    }


#define implies(A,B) (A==(A&B))

#endif
